# LeanEngine Node.js SDK

## 安装

```bash
npm install --save leanengine leancloud-storage@3 --save
```

建议使用 Node.js 8.0 以上的版本（可在 `package.json` 中设置 `engines.node` 为 `8.x`）。

## 文档

* 快速入门：<https://leancloud.cn/docs/leanengine_quickstart.html>
* 网站托管开发指南：<https://leancloud.cn/docs/leanengine_webhosting_guide-node.html>
* 云函数开发指南：<https://leancloud.cn/docs/leanengine_cloudfunction_guide-node.html>
* 云引擎命令行工具使用详解：<https://leancloud.cn/docs/leanengine_cli.html>
* API 参考文档：<https://github.com/leancloud/leanengine-node-sdk/blob/master/API.md>

## 项目示例

* 项目模板：<https://github.com/leancloud/node-js-getting-started>
* Node.js Demo 汇总：<https://github.com/leancloud/leanengine-nodejs-demos>
* 微信公众平台：<https://leancloud.cn/docs/webhosting_weixin.html>
* 微博 OAuth 授权验证：<https://leancloud.cn/docs/webhosting_oauth.html>

## 历史版本

见 [Releases](https://github.com/leancloud/leanengine-node-sdk/releases)

- `npm install leanengine@2 --save` 升级说明见 [v3.0.0](https://github.com/leancloud/leanengine-node-sdk/releases/tag/v3.0.0)
- `npm install leanengine@1 --save` 升级说明见 [v2.0.0](https://github.com/leancloud/leanengine-node-sdk/releases/tag/v2.0.0)
- `npm install leanengine@0 --save` 升级说明见 [升级到云引擎 Node.js SDK 1.0](https://leancloud.cn/docs/leanengine-node-sdk-upgrade-1.html)

若有意参与开发请看 [CONTRIBUTING.md](<https://github.com/leancloud/leanengine-node-sdk/blob/master/CONTRIBUTING.md>)。
